// record the change in the cache size to study the cache replacement policy

import java.io.*;
import java.util.*;
import java.lang.*;

class CacheSize{
    private static CacheRecord CRecord;
    private static Thread CRecord_thread;
    public static boolean isTerminate = false;
    public static int checkTimes;

    public static void main(String[] args){
	System.out.println("the input arguments are: " + args.length);
	int interval = (Integer.valueOf(args[0])).intValue();
	String cachePath = args[1];
	checkTimes =  (Integer.valueOf(args[2])).intValue();

	CRecord = new CacheRecord(interval, cachePath);
	CRecord_thread = new Thread(CRecord, "CacheRecord");
	CRecord_thread.start();

	//wait for the thread to finish
	try{
	    CRecord_thread.join();
	}catch(InterruptedException e){
	    e.printStackTrace();
	}
    }

    static public void terminateProgram(){
	CRecord_thread.interrupt();
	isTerminate = true;
    }
}

class CacheRecord implements Runnable{
    int checkFreq;
    String cachePath;
    Vector cacheSize;

    public CacheRecord(int freq, String path){
	checkFreq = freq;
	cachePath = path;
	cacheSize = new Vector();
    }

    /** save to the file. */
    public void storeFile(){
        try{    
            FileOutputStream fout= new  FileOutputStream("cacheSize");
            ObjectOutputStream obj_out = new ObjectOutputStream(fout);
            obj_out.writeObject(cacheSize);
            obj_out.flush();
            fout.close();
        }catch(Exception e){
            System.out.println("In WorkLoadGen:save workload file exception"); 
             e.printStackTrace(); 
        }
    }

    public void run(){
	//read in the directory and get the size of the directory
	File cacheDir = new File(cachePath);
	
	//for debug
	if( cacheDir.isDirectory() ){
	    System.out.println("it is a directory.");
	}
	while(!CacheSize.isTerminate){
	//record the total size of this directory
	File[] filelist = cacheDir.listFiles();
	int totalSize = 0;

	for(int i = 0; i < filelist.length; i++){
	    totalSize += filelist[i].length();
	    System.out.println("the file is: " + filelist[i].getPath() + " the size of this file is: " + filelist[i].length());
	}
	System.out.println("the total size of this directory is: " + totalSize);
	//store the size in a file
	cacheSize.addElement(new Integer(totalSize));
	

	//wake up at controlled interval to check the cache size
	try{
	    Thread.sleep(checkFreq);
	}catch(InterruptedException e){
	    e.printStackTrace();
	}
	CacheSize.checkTimes--;
	if(CacheSize.checkTimes == 0)
	    CacheSize.terminateProgram();
	    storeFile();
	}
    }
}
