// this class parse the input file and get info from user browsing
// the command line should be: java TraceAna <inputTracefile>.

import java.io.*;
import java.util.*;
import java.lang.*;

class TraceAna{
    public static void main(String[] args){
	if( args.length < 1)
	    System.out.println("please input the trace file.");
	String trace = args[0];
	String outTrace = args[1];
	
	//read in the trace file
	try{
	    int total = 0; // total number of clicks.
	    int hit = 0; // number of hits on cache.
	    long totalbyte = 0; //total number of bytes being accessed
	    long hitbyte = 0; //number of bytes that in cache.
	    long avgbyte = 0;
	    double hitRate = 0;
	    double byteHitRate = 0;
	    int siteCount = 0;
	    int[] beanCount = new int[15];
	    int[] beanHit = new int[15];
	    for(int i = 0; i < 15; i++){
		beanCount[i] = 0;
		beanHit[i] = 0;
	    }
	    PrintWriter p = new PrintWriter(new FileOutputStream(outTrace),true);
	    PrintWriter pCount = new PrintWriter(new FileOutputStream(trace+"size"), true);
	    PrintWriter pHit = new PrintWriter(new FileOutputStream(trace+"hit"),true);

	    BufferedReader in = new BufferedReader(new FileReader(trace));
	    for(;;){
		String line = in.readLine();
		if(line == null)
		    break;
		
		//start treating a new browsing page.
		if( !line.startsWith("#") ){
		    System.out.println("the reading line is: " + line);
		    //read the line that retrieve the page
		    StringTokenizer st = new StringTokenizer(line,",");
		    String name = new String();
		    long size = 0;
		    boolean inCache = false;
		    
		    for(int i = 0; i < 7; i++){
			String temp = st.nextToken();
			
			if(i == 0)
			    name = temp.substring(1, temp.length()-1);
			if(i == 3){
			    size = (Long.valueOf(temp.substring(1, temp.length()-1))).longValue();
			    beanCount[seperate(size)]++;
			}
			if(i == 6){
			    int count = (Integer.valueOf(temp)).intValue();
			    System.out.println("the count is: " + count);
			    if(count > 2 && count != 3)
				inCache = true;
			    }
		    }
		    

		    //collect statistical info
		    total++;
		    totalbyte += size;
		    if(inCache){
			hit++;
			hitbyte += size;
			beanHit[seperate(size)]++;
		    }
			
		    FileElement fe = new FileElement(name, size, inCache);
		    fe.toFile(p,total);
		}
		else{
		     //read the line that retrieve the page
		    StringTokenizer stSite = new StringTokenizer(line,",");
		    String site = new String();
		    for(int j = 0; j<3; j++){
			site = stSite.nextToken();
			if(j == 2)
			    siteCount++;
		    }
		}
	    }
	    hitRate = (double)hit/total;
	    byteHitRate = (double)hitbyte/totalbyte;
	    avgbyte = totalbyte/total;
	    p.println();
	    p.print("final statistics:********************");
	    p.print("hitRate is: " + hitRate + "byteHitRate is: " + byteHitRate+"\n");
	    p.print("total hit is: " + total + "totalbytes is: " + totalbyte+"\n");
	    for(int k = 0; k < 15; k++){
		System.out.println(k + "sizedis: " + beanCount[k] + "hitdis: " + beanHit[k]);
		toFile(pCount, k, beanCount[k]);
		toFile(pHit, k, beanHit[k]);
		//pCount.println(k+"        " + beanCount[k]);
		//pHit.println(k+ "        " + beanHit[k]);
	    }
	    
	    System.out.println("the hitRate is: " + hitRate + " the byteHitRate is: " + byteHitRate+ " totalhit: " + total + " totalbyte: " + totalbyte + " totalSite: " + siteCount + "avgSize: " + avgbyte);
	}catch(IOException e){
	    e.printStackTrace();
	}
	
    }

    public static int seperate(long filesize){
	if(filesize <= 1024)
	    return 0;
	else if(filesize <= 2048)
	    return 1;
	else if(filesize <= 3072)
	    return 2;
	else if(filesize <= 4096)
	    return 3;
	else if(filesize <= 5120)
	    return 4;
	else if( filesize <= 10240)
	    return 5;
	else if( filesize <= 15360)
	    return 6;
	else if(filesize <= 20480)
	    return 7;
	else if(filesize <= 25600)
	    return 8;
	else if(filesize <= 30720)
	    return 9;
	else if(filesize <= 35840)
	    return 10;
	else if(filesize <= 40960)
	    return 11;
	else if(filesize <= 46080)
	    return 12;
	else if( filesize <= 51200)
	    return 13;
	else
	    return 14;
    }
    public static void toFile(PrintWriter p, int index, int content){
	 p.println(index + "        " + content);
     }
}


class FileElement{
    String fileName;  //filename
    long fileSize; //in byte
    boolean inCache;

    public FileElement(String name, long size,  boolean inC){
	fileName = name;
	fileSize = size;
	inCache = inC;
    }

    public String getFileName(){
	return fileName;
    }

    public long getSize(){
	return fileSize;
    }

    public boolean isInCache(){
	return inCache;
    }

    public String toString(){
	if(inCache)
	    return fileName + " " + fileSize + " " + 1;
	else
	    return fileName + " " + fileSize  + " " + 0;
    }

    
    /** Funtion to output the generated wordload to the file.
     * @para p the PrintWriter Object to print to a text-output stream.
     * @para index counts index for each order.
     */
    /* public void toFile(PrintWriter p, int index){
	p.print("fileName: " + fileName + "  fileSize: " + fileSize + " inCache: " );
	if( inCache )
	    p.print("true");
	else
	    p.print("false");
	p.println("//");
	}*/

     public void toFile(PrintWriter p, int index){
	 p.println(index + "        "+ fileSize);
     }
 
}
