/** Histogram visualization */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class HistFrame extends JFrame{
    Hist h;

    public HistFrame(int n, int m1, int m2, String s){
	super(s);
	h = new Hist(n,m1, m2, s);
	getContentPane().add(h, BorderLayout.CENTER);
    }

    public void update(int n){
	h.update(n);
    }
}


class Hist extends JPanel {

    private int num;
    private int max;
    private int max_g;
    private String name;
    

    final Color bg = Color.white;
    final Color fg = Color.black;

    public Hist(int n, int m1, int m2, String s) {
	num = n;
	max = m1;
	max_g = m2;
	name = s;

        //Initialize drawing colors, border, opacity.
        setBackground(bg);
        setForeground(fg);
        setBorder(BorderFactory.createCompoundBorder(
                BorderFactory.createRaisedBevelBorder(),
                BorderFactory.createLoweredBevelBorder()));
	
    }

    public void update(int n){
	num = n;
	repaint();
    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g);      //clears the background

        Insets insets = getInsets();
        int currentWidth = getWidth() - insets.left - insets.right;
        int currentHeight = getHeight() - insets.top - insets.bottom;

        // draw the coordinate system
	int margin = 40;
        int x0 = insets.left + margin;
        int y0 = insets.top + margin;
        int width =  currentWidth - 2*margin;
        int height = currentHeight - 2*margin;

	g.drawRect(x0, y0, width, height);

	for(int i = 1; i < 10;  i++)
	    g.drawLine(x0, y0 + (int)((double)height / 10) * i+ 2, x0 + 10, y0+(int)((double)height/10) * i+2);

        for(int i = 10; i >= 0; i--)
	    g.drawString( (new Integer((int)(0.1*i*max_g))).toString(), 
			  x0-20, y0 + height/10*(10 - i));
	
	
	g.drawString(name, currentWidth/2-30, y0 + height + margin - 5);

	g.drawRect(x0+(int)(width/2) - 20, y0+height-(int)((double)num/max*height), 
		   40, (int)((double)num/max*height));

    }
}
